require("engine")
require("level")
require("title")
require("edit")
require("tiles")
require("menu")

require("gui")
function Font:draw(...)
    local arg = {...}
    arg[3] = arg[3] - 3
    cuz.font_draw(self.name,self.points,table.unpack(arg))
end
function Font:size(...)
    local w,h = cuz.font_size(self.name,self.points,...)
    h = h - 6
    return w,h
end

function game_init()
    cuz.filter = "nearest"
    cuz.caption = "Turkey Tomahawk Turbo"
    cuz.appid = "Turkey Tomahawk Turbo"
    
    global("GAME")
    GAME = GAME or {}
    GAME.release = true

    GAME.SW = 240
    GAME.SH = 160
    GAME.sw = GAME.SW
    GAME.sh = GAME.SH
    GAME.TW = 16
    GAME.TH = 16
    GAME.tw = GAME.TW
    GAME.th = GAME.TH
    GAME.cur = 1
    GAME.font = Font("gfont",0)
    
    engine_init()
    title_init()
    level_init()
    edit_init()
    tiles_init()
    menu_init()
    
    cuz.view_set(0,0,GAME.sw,GAME.sh)
    cuz.stream_play("fuelship-syphus",1.0)
end

function init() GAME.engine:init() end
function event(e) GAME.engine:event(e) end
function loop(t) GAME.engine:loop(t) end
function paint() GAME.engine:paint() end
    
game_init()