require("util")

global("LEVELS")
LEVELS = {"5.map","9.map","6.map","7.map","8.map"}

function game_next()
    if GAME.level.next then
        GAME.engine:next(GAME.level.next) 
        return
    end
    
    GAME.cur = GAME.cur + 1
    if GAME.cur > #LEVELS then
        GAME.cur = 1
        GAME.engine:next(GAME.modules.menu)
        return
    end
    
    game_play()
end

function game_quit()
    if GAME.level.next then
        GAME.engine:next(GAME.level.next) 
        return
    end
    
    GAME.engine:next(GAME.modules.menu)
end



function game_play()
    local fname = LEVELS[GAME.cur]
    GAME.level.data = json.decode(cuz.file_load(fname))
    GAME.level.scene = scene_load(GAME.level.data)
    GAME.level.next = nil
    scene_init(GAME.level.scene)
    GAME.engine:next(GAME.modules.level_play)
end

function menu_init()
    GAME.modules.menu = GAME.modules.menu or {}
    GAME.menu = GAME.menu or {}
    local obj = GAME.modules.menu
    
    function obj:init()
        obj.t = 0
        
        self.gui = Gui(Rect(0,0,GAME.SW,GAME.SH))
        
        self.start = Button(Label(GAME.font,"START <X>"),function () event({type='start'}) end,GBackground("white",0x000000,0x004058))
        self.gui:add(self.start,Rect(60,GAME.SH/2+22,120,20))
            
        local ww = 126/2
        local hh = 34/2
        self.charity = Button(Image("pixel-button-126x34",Rect(ww,hh)),function () event({type='charity'}) end,GBackground("white",0x000000,0x004058))
            
        self.gui:add(self.charity,Rect(60,GAME.SH/2+22+24,120,20))
            
        self.gui.focus = self.start
        
        self.start.next = self.charity
        self.charity.next = self.start
        
    end
    function obj:event(e)
        if e.type == 'keydown' and e.name == 'Left' then
            GAME.cur = max(1,GAME.cur - 1)
        end
        if e.type == 'keydown' and e.name == 'Right' then
            GAME.cur = min(#LEVELS,GAME.cur + 1)
        end
        
        if e.type == 'keydown' and (e.name == 'Down' or e.name == 'Up') then
            self.gui.focus = self.gui.focus.next
        end
        
        if e.type == 'charity' then
            cuz.ext_call("open_url","http://www.lovelandhabitatforhumanity.org/")
        end
        
        if e.type == 'start' then
            game_play()
        end
        
        if e.type == 'keydown' and e.name == 'D' then
            GAME.engine:next(GAME.modules.edit)
        end
        
        if e.type == 'keydown' and (e.name == 'Z' or e.name == 'X') then
            self.gui.focus.click()
        end

        
        if e.type == 'keydown' and e.name == 'Escape' then
            cuz.ext_call("exit")
        end
        
        self.gui:event(e)
    end
    function obj:loop(t)
        obj.t = obj.t+t
        
        self.start.widget.text =  "START <"..GAME.cur..">"
        
        self.gui:loop(t)
    end
    function obj:paint()
        cuz.view_set(0,0,GAME.sw,GAME.sh)
        local ww = 160
        local hh = 80
        cuz.image_draw("bkgr1",-round((math.cos(obj.t/5)+1)*160/2),0,480,320)
        local yy = -60+obj.t * 30
        cuz.image_draw("logo",(GAME.SW-ww)/2,round(math.min((GAME.SH-hh-30)/2-12,yy)),ww,hh)

        hh = 12
        cuz.image_draw("sig",(GAME.SW-ww)/2,0,ww,12)
        ww = 240
        cuz.image_draw("help",(GAME.SW-ww)/2,GAME.SH-12,ww,12)
        
        self.gui:draw()
    end
end